// MyWindow.cpp: implementation of the CMyWindow class.
//
//////////////////////////////////////////////////////////////////////
/*
Copyright 2001 Anish Mistry. All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

   1. Redistributions of source code must retain the above copyright notice, 
   this list of conditions and the following disclaimer.
   2. Redistributions in binary form must reproduce the above copyright notice,
   this list of conditions and the following disclaimer in the documentation 
   and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY ANISH MISTRY ``AS IS'' AND ANY EXPRESS OR IMPLIED 
WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY 
AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS 
OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

The views and conclusions contained in the software and documentation are those
of the authors and should not be interpreted as representing official policies,
either expressed or implied, of the Anish Mistry or AM Productions.

* Variation of the FreeBSD License. http://www.freebsd.org/copyright/freebsd-license.html
*/

#include "stdafx.h"
#include "MyWindow.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CMyWindow::CMyWindow()
{
	m_hInstance = GetModuleHandle(NULL);
	m_hWnd = NULL;
	m_pWindowClass[0] = '\0';
	// init the ThunkData with the this pointer so that this can be subclassed
	ThunkInit(m_Thunk, this);
}

CMyWindow::~CMyWindow()
{

}

unsigned long int CMyWindow::Init(HWND hParent,char *pWindowName, unsigned long int dwExStyle,unsigned long int dwStyle, int x, int y,int nWidth, int nHeight, HMENU hMenu, int nCmdShow)
{// begin Init
	m_hWnd = CreateWindowEx(dwExStyle,m_pWindowClass,pWindowName,dwStyle,x,y,nWidth,nHeight,hParent,hMenu,m_hInstance,NULL);
	if(!m_hWnd)
		return 0;
	ShowWindow(m_hWnd, nCmdShow);
	UpdateWindow(m_hWnd);
	return 1;
}// end Init

HWND CMyWindow::GetSafeHwnd()
{// begin GetSafeHwnd
	return m_hWnd;
}// end GetSafeHwnd

LRESULT CMyWindow::WndProc(HWND hWnd,UINT nMessage,WPARAM wParam,LPARAM lParam)
{// begin WndProc
	switch(nMessage)
	{// begin nMessage switch
	case WM_COMMAND:
		OnCommand(wParam,lParam);
		break;
	}// end nMessage swtich
	return DefWindowProc(hWnd, nMessage, wParam, lParam);
}// end WndProc

unsigned long int CMyWindow::OnCommand(WPARAM wParam, LPARAM lParam)
{// begin OnCommand
	return 0;
}// end OnCommand


ATOM CMyWindow::RegisterClass(char *pWindowClass,unsigned long int nIconID, unsigned long int nMenuID)
{// begin RegisterClass
	lstrcpy(m_pWindowClass,pWindowClass);
	WNDCLASSEX wcex = {NULL};

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)(void *)m_Thunk;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= m_hInstance;
	wcex.hIcon			= (HICON)LoadImage(m_hInstance, (LPCTSTR)nIconID,IMAGE_ICON,32,32,LR_DEFAULTCOLOR);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= (LPCSTR)nMenuID;
	wcex.lpszClassName	= m_pWindowClass;
	wcex.hIconSm		= (HICON)LoadImage(m_hInstance, (LPCTSTR)nIconID,IMAGE_ICON,16,16,LR_DEFAULTCOLOR);
	wcex.cbSize = sizeof(wcex); 

	return RegisterClassEx(&wcex);
}// end RegisterClass
